﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace LAB6
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        //Globális változók
        Random rand = new Random();
        double[] meret = new double[30];  //30 db méret
        double nevlegesMeret = 3.200;
        double tures = 0.02;

        private void Form1_Load(object sender, EventArgs e)
        {
            Text = "6. óra - Gyakorlás";
            button1.Text = "Mérési adatok generálása";
            button2.Text = "Kiértékelés";
            label1.Text = "Mérési adatok [mm]";
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //mérési adatok generálása
            listBox1.Items.Clear();
            for (int i = 0; i < meret.Length; i++)
            {
                //3.200±0.020 mm felbontás 0.001 mm
                int t = 40; // 0.001 * 40 rész
                double offset = 0.00; // eltolás
                // HF kisérletezés
                // vegyük kisebbre t értékét t=20, így már meg fog felelni 
                // toljuk el az adatokat, offset = 0.01 -> Cpk = kisebb lesz, mint 1
                meret[i] = Math.Round(((double)rand.Next(t + 1) - t / 2) / 1000 + nevlegesMeret + offset, 3);
                listBox1.Items.Add($"{meret[i]:F03}"); //:F03 - float 3 tizedesjegyű 0-val feltöltve
            }
        }


        private void button2_Click(object sender, EventArgs e)
        {
            listBox2.Items.Clear();

            // terjedelem meghatározása 3db 10-es részcsoportra

            //1. részcsoport 0-10
            double min = meret[0];
            double max = meret[0];
            for (int i = 1; i < 10; i++)
            {
                if (min > meret[i]) min = meret[i];
                if (max < meret[i]) max = meret[i];
            }
            double R1 = max - min;
            listBox2.Items.Add($"R1: {R1:F03} mm");

            //2.részcsoport 10-20
            min = meret[10];
            max = meret[10];
            for (int i = 10; i < 20; i++)
            {
                if (min > meret[i]) min = meret[i];
                if (max < meret[i]) max = meret[i];
            }
            double R2 = max - min;
            listBox2.Items.Add($"R2: {R2:F03} mm");

            //3.részcsoport 20-30
            min = meret[20];
            max = meret[20];
            for (int i = 20; i < 30; i++)
            {
                if (min > meret[i]) min = meret[i];
                if (max < meret[i]) max = meret[i];
            }
            double R3 = max - min;
            listBox2.Items.Add($"R3: {R3:F03} mm");

            //terjegyelm átlaga
            double Ravg = (R1 + R2 + R3) / 3;
            listBox2.Items.Add($"Átlagos terjedelem: {Ravg:F4} mm");

            //becsült szórás
            double A10 = 0.32; //10-es részcsoport állandója
            double Sr = A10 * Ravg;
            listBox2.Items.Add($"Becsült szórás: {Sr:F4} mm");

            //Átlag
            double avg = Math.Round(meret.Average(), 3);

            //eredmény megadása 3*szórás (99.73%-os konfigencia)
            int k = 3;
            double Sr3 = Math.Round(k * Sr, 3);
            listBox2.Items.Add($"Eredmény: {avg:F3}±{Sr3:F3} mm");

            //Ellenőrzés
            if (nevlegesMeret + tures >= (avg + Sr3)
                && nevlegesMeret - tures <= (avg - Sr3))
                listBox2.Items.Add("A gyártás megfelelt!");
            else
                listBox2.Items.Add("A gyártás nem megfelelő!");

            //Cp, Cpk meghatározása
            int kp = 3;
            double USL = nevlegesMeret + tures;
            double LSL = nevlegesMeret - tures;
            double Cp = (USL - LSL) / (2 * kp * Sr);
            double Cpk = Math.Min((USL - avg) / (kp * Sr), (avg - LSL) / (kp * Sr));
            listBox2.Items.Add($"Cp: {Cp:F3}");
            listBox2.Items.Add($"Cpk: {Cpk:F3}");


            // Elemek rendezezése egy másik tömbben, hogy ne modósítsuk a mért értkeket
            // létre kell hozni egy ugyanakkora tömböt és át kell másolni az elemeket
            double[] rendezettMeret = new double[meret.Length];
            meret.CopyTo(rendezettMeret, 0);

            //Növekvő sorba rendezés
            for (int i = 0; i < rendezettMeret.Length; i++)
            {
                for (int j = 0; j < rendezettMeret.Length - 1 - i; j++)
                {
                    if (rendezettMeret[j] > rendezettMeret[j + 1])
                    {
                        double tmp = rendezettMeret[j];
                        rendezettMeret[j] = rendezettMeret[j + 1];
                        rendezettMeret[j + 1] = tmp;
                    }
                }
            }
            //Középérték
            listBox2.Items.Add($"Median: {rendezettMeret[15]:F03} mm");
        }
    }
}
